10 REMark 
20 REMark  Mathematische Felder
30 REMark  Version 14/2/90
40 REMark 
50 :
100 EINGABE
110 REPeat HAUPT
120   ZEICHNEN
130   Ausschnitt
140 END REPeat HAUPT
150 CLS#0: PRINT#0," ...to be continued "
160 STOP
170 :
180 :
190 REMark ==============================
200 :
210 :
220 DEFine PROCedure EINGABE
230  PAPER 3: INK 7: BORDER 1,7: CLS
240  CSIZE 1,1: PRINT " Mathematische Felder": CSIZE 0,0
250  PRINT\"Bildbereich:"
260  INP "px1",px1,50
270  INP "px2",px2,100
280  INP "pxs",pxs,1
290  INP "py1",py1,50
300  INP "py2",py2,100
310  INP "pys",pys,1
320  PRINT\"Definitionsbereich:"
330  INP "x1",x1,-2
340  INP "x2",x2,2
350  INP "y1",y1,-2
360  INP "y2",y2,2
370  PRINT: INP "REFRESH?",REFR$,"j"
380  IF "j" INSTR REFR$: REFR=1: ELSE REFR=0
390  INP "CLEAR?",CL$,"n"
400  IF "j" INSTR CL$: SCLR 0
410  CLS
420  PRINT\"Bezugspunkte:"
430  PRINT "Punkt P1:"
440  INP "x",P1_x,0
450  INP "y",P1_y,0
460  PRINT "Punkt P2:"
470  INP "x",P2_x,1
480  INP "y",P2_y,1
490  wenig=EXP(PI)*1E-10
500  PRINT "Konstanten:"
510  INP "A",A,1
520  INP "B",B,1
530  INP "C",C,0
540 END DEFine EINGABE
550 :
560 :
570 DEFine PROCedure ZEICHNEN
580  REMark SCLR 0
590  REMark DRAW px1,py1 TO px1,py2, 3
600  REMark DRAW px1,py2 TO px2,py2, 3
610  REMark DRAW px2,py2 TO px2,py1, 3
620  REMark DRAW px2,py1 TO px1,py1, 3
630  x=P1_x:y=P1_y:CALC_INV: PLOT px,py,7
640  x=P2_x:y=P2_y:CALC_INV: PLOT px,py,7
650  IF REFR:REFRESH
660  FOR px=px1 TO px2 STEP pxs
670    FOR py=py1 TO py2 STEP pys
680      CALC
690      RICHT=(x-P1_x)/(y-P1_y+wenig)
700      LIMIT_RICHT
710      DIST=(x-P2_x)^2 + (y-P2_y)^2
720      z=A * RICHT * SIN( B*DIST+C )
730      z=2*LN(ABS(z+(1E-10)*(z=0)))
740      col=z MOD 7
750      PLOT px,py,col
760   END FOR py
770   IF REFR: REFRESH
780  END FOR px
790  BEEP 1000,0
800 END DEFine ZEICHNEN
810 :
820 :
830 DEFine PROCedure INP(Quest$,Var,DVar)
840  LOCal Var$
850  INPUT ""&Quest$&" ("&DVar&"): ";Var$;
860  IF Var$="" THEN Var=DVar: PRINT Var: RETurn 
870  Var=Var$: PRINT
880 END DEFine INP
890 :
900 :
910 DEFine PROCedure CALC
920  REMark   aus Bildschirmkoordinaten
930  REMark   mathematische Koordinaten
940  REMark   (px|py)  (x|y)
950  x=(px-px1)/(px2-px1)
960  y=(py-py1)/(py2-py1)
970  x=x*(x2-x1)+x1
980  y=y*(y2-y1)+y1
990 END DEFine CALC
1000 :
1010 :
1020 DEFine PROCedure Ausschnitt
1030  a1=px1: b1=py1
1040  a2=a1+(px2-px1) DIV 4
1050  b2=b1+(py2-py1) DIV 4
1060  REFRESH
1070  REPeat LOOP1
1080    REPeat LOOP2
1090      BOX
1100      key1=KEYROW(1)
1110      key2=KEYROW(7)
1120      IF NOT key1 THEN BOX: NEXT LOOP2
1130      BOX
1140      SELect ON key2
1150        =1: delta=10
1160        =4: delta=4
1170        =5: delta=20
1180        =REMAINDER : delta=1
1190      END SELect 
1200      SELect ON key1
1210        =2:   a1=a1-delta
1220        =16:  a1=a1+delta
1230        =4:   b1=b1-delta
1240        =128: b1=b1+delta
1250        =64:  EXIT LOOP1
1260        =8:   EXIT HAUPT
1270        =REMAINDER : NEXT LOOP2
1280      END SELect 
1290      EXIT LOOP2
1300    END REPeat LOOP2
1310    IF a1<px1 THEN a1=px1
1320    IF b1<py1 THEN b1=py1
1330    a2=a1+(px2-px1) DIV 4
1340    b2=b1+(py2-py1) DIV 4
1350    IF a2>px2 THEN a2=px2
1360    IF b2>py2 THEN b2=py2
1370  END REPeat LOOP1
1380  px=a1: py=b1: CALC
1390  x1_neu=x: y1_neu=y
1400  px=a2: py=b2: CALC
1410  x2_neu=x: y2_neu=y
1420  x1=x1_neu: x2=x2_neu
1430  y1=y1_neu: y2=y2_neu
1440 END DEFine Ausschnitt
1450 :
1460 :
1470 DEFine PROCedure BOX
1480  ALINE a1,b1 TO a2,b1 ,7
1490  ALINE a2,b1 TO a2,b2 ,7
1500  ALINE a2,b2 TO a1,b2 ,7
1510  ALINE a1,b2 TO a1,b1 ,7
1520 END DEFine BOX
1530 :
1540 :
1550 DEFine PROCedure CALC_INV
1560  REMark aus mathematische Koordinaten
1570  REMark Bildschirmkoordinaten
1580  REMark (x|y)  (px|py)
1590  x=(x-x1)/(x2-x1)
1600  y=(y-y1)/(y2-y1)
1610  px=x*(px2-px1)+px1
1620  py=y*(py2-py1)+py1
1630 END DEFine CALC_INV
1640 :
1650 :
1660 DEFine PROCedure LIMIT_RICHT
1670  IF RICHT < -1E6: RICHT=-1E6
1680  IF RICHT >  1E6: RICHT= 1E6
1690 END DEFine LIMIT_RICHT
